#define NO_INDIRECTION

#ifdef NO_INDIRECTION
#define ACIACR (*(volatile unsigned char *)0xE004)
#define ACIASR (*(volatile unsigned char *)0xE004)
#define ACIATX (*(volatile unsigned char *)0xE005)
#define ACIARX (*(volatile unsigned char *)0xE005)
#else
volatile unsigned char *ACIACRp = (volatile unsigned char *)0xE004;
#define ACIACR (*ACIACRp)
volatile unsigned char *ACIASRp = (volatile unsigned char *)0xE004;
#define ACIASR (*ACIASRp)
volatile unsigned char *ACIATXp = (volatile unsigned char *)0xE005;
#define ACIATX (*ACIATXp)
volatile unsigned char *ACIARXp = (volatile unsigned char *)0xE005;
#define ACIARX (*ACIARXp)
#endif


static inline int getchar(void) {
  while ((ACIASR&1) == 0) /*wait*/;
  return ACIARX;
}

static inline void aciainit(void) {
  ACIACR = 3;
  ACIACR = 0b00010101;
}

static inline int cr(void) {
  while ((ACIASR&2) == 0) /*wait*/;
  ACIATX = '\r';
}

static inline int putchar(const int c) {
  while ((ACIASR&2) == 0) /*wait*/;
  ACIATX = c;
  if (c == '\n') cr();
}

static inline int printstring(const char *s) {
  while (*s) (void)putchar(*s++);
  return 0;
}

static inline int puts(const char *s) {
  printstring(s); putchar('\n');
  return 0;
}

int main(int argc, char **argv) {
  // Assume we're running from S-BUG and ACIA is set up already.
  // All that remains to do is load this code into a suitable
  // region of memory and jump to it from S-BUG.
  // (A proper loader and CLI will be added later)

  // aciainit();
  const char Txt[] = "\r6809 CLI\r\nCommand: ";
  (void)printstring(Txt); // gcc maps built-in printf to built-in puts and putchar if possible.
  for (;;) {
    int c = getchar();
    if (c == ('D'&31)) break;
    putchar(c);
    if (c == '\r') printstring(Txt+10);
  }
  // re-enter S-BUG
  asm(" jmp [0XF800]");
  return 0;
}
